{{ band_pass.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_addr, parm
                add     parm, #4
		mov	out_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  value, in_addr
                call    #filter
                wrlong  value, out_addr
                jmp     #:filtloop


filter          
                sar     value, #10
                call    #stage1          ' stage gain = 47.5916406516, cumul actual gain = 0.71624383762
                                         ' poles only = 733.433689723
                sar     value, #4
                call    #stage2          ' stage gain = 15.8619476495, cumul actual gain = 0.703632184666
                                         ' poles only = 263.043461789
                sar     value, #3
                call    #stage3          ' stage gain = 9.37763490844, cumul actual gain = 0.811091691269
                                         ' poles only = 191.276585466
                sar     value, #3
                call    #stage4          ' stage gain = 6.82045585815, cumul actual gain = 0.671657418267
                                         ' poles only = 160.170487436
                shl     value, #3
                call    #stage5          ' stage gain = 5.91929428152, cumul actual gain = 0.959935528487
                                         ' poles only = 9.32624077065
                shl     value, #2
                call    #stage6          ' stage gain = 2.41263468928, cumul actual gain = 0.876940519953
                                         ' poles only = 4.2656878737
                shl     value, #1
                call    #stage7          ' stage gain = 1.77878944404, cumul actual gain = 0.524948891195
                                         ' poles only = 4.31872872985
                shl     value, #2
                call    #stage8          ' stage gain = 1.58608151782, cumul actual gain = 0.969991950773
                                         ' poles only = 5.44996089062
                shl     value, #3
filter_ret      ret                      ' cumul actual gain = 0.672148229086

value           long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.9873504638671875+0.064178466796875j), (0.9873504638671875-0.064178466796875j)] }}

coeff1_b1                                ' value += t * -1.974701 [ +1.f9860 hex ]
                sub     value, t
                sub     value, t
                sar     t, #5
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
coeff1_b1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff1_b2                                ' value += t * 0.978973 [ +0.fa9e0 hex ]
                add     value, t
                sar     t, #5
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #4
                sub     value, t
coeff1_b2_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff1_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff1_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff1_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff1_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage1          
                neg     t, w11
                call    #coeff1_b1       ' value -= w11 * -1.974700927734375
                neg     t, w12
                call    #coeff1_b2       ' value -= w12 * 0.978973388671875
                mov     w10, value       ' w10 = value
                mov     t, w11
                call    #coeff1_a1       ' value += w11 * -1.0
                mov     t, w12
                call    #coeff1_a2       ' value += w12 * 0.0
                mov     w12, w11
                mov     w11, w10         ' w12 <- w11 <- w10
stage1_ret      ret

w10             long    0
w11             long    0
w12             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.9661865234375+0.0583343505859375j), (0.9661865234375-0.0583343505859375j)] }}

coeff2_b1                                ' value += t * -1.932373 [ +1.eeb00 hex ]
                sub     value, t
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
coeff2_b1_ret   ret                      ' 60 cycles (I2S: 0.610 us, standard: 0.750 us) 15 instructs

coeff2_b2                                ' value += t * 0.936905 [ +0.efd90 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #6
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
coeff2_b2_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff2_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff2_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff2_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff2_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage2          
                neg     t, w21
                call    #coeff2_b1       ' value -= w21 * -1.932373046875
                neg     t, w22
                call    #coeff2_b2       ' value -= w22 * 0.9369049072265625
                mov     w20, value       ' w20 = value
                mov     t, w21
                call    #coeff2_a1       ' value += w21 * -1.0
                mov     t, w22
                call    #coeff2_a2       ' value += w22 * 0.0
                mov     w22, w21
                mov     w21, w20         ' w22 <- w21 <- w20
stage2_ret      ret

w20             long    0
w21             long    0
w22             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.94403076171875+0.0457763671875j), (0.94403076171875-0.0457763671875j)] }}

coeff3_b1                                ' value += t * -1.888062 [ +1.e3580 hex ]
                sub     value, t
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
coeff3_b1_ret   ret                      ' 60 cycles (I2S: 0.610 us, standard: 0.750 us) 15 instructs

coeff3_b2                                ' value += t * 0.893280 [ +0.e4ae0 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #3
                sub     value, t
coeff3_b2_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff3_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff3_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff3_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff3_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage3          
                neg     t, w31
                call    #coeff3_b1       ' value -= w31 * -1.8880615234375
                neg     t, w32
                call    #coeff3_b2       ' value -= w32 * 0.893280029296875
                mov     w30, value       ' w30 = value
                mov     t, w31
                call    #coeff3_a1       ' value += w31 * -1.0
                mov     t, w32
                call    #coeff3_a2       ' value += w32 * 0.0
                mov     w32, w31
                mov     w31, w30         ' w32 <- w31 <- w30
stage3_ret      ret

w30             long    0
w31             long    0
w32             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.9235076904296875+0.019805908203125j), (0.9235076904296875-0.019805908203125j)] }}

coeff4_b1                                ' value += t * -1.847015 [ +1.d8d60 hex ]
                sub     value, t
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
coeff4_b1_ret   ret                      ' 76 cycles (I2S: 0.773 us, standard: 0.950 us) 19 instructs

coeff4_b2                                ' value += t * 0.853256 [ +0.da6f0 hex ]
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #4
                sub     value, t
coeff4_b2_ret   ret                      ' 72 cycles (I2S: 0.732 us, standard: 0.900 us) 18 instructs

coeff4_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff4_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff4_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff4_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage4          
                neg     t, w41
                call    #coeff4_b1       ' value -= w41 * -1.847015380859375
                neg     t, w42
                call    #coeff4_b2       ' value -= w42 * 0.8532562255859375
                mov     w40, value       ' w40 = value
                mov     t, w41
                call    #coeff4_a1       ' value += w41 * -1.0
                mov     t, w42
                call    #coeff4_a2       ' value += w42 * 0.0
                mov     w42, w41
                mov     w41, w40         ' w42 <- w41 <- w40
stage4_ret      ret

w40             long    0
w41             long    0
w42             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.7243194580078125+0.5449981689453125j), (0.7243194580078125-0.5449981689453125j)] }}

coeff5_b1                                ' value += t * -1.448639 [ +1.72da0 hex ]
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
coeff5_b1_ret   ret                      ' 72 cycles (I2S: 0.732 us, standard: 0.900 us) 18 instructs

coeff5_b2                                ' value += t * 0.821655 [ +0.d2580 hex ]
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff5_b2_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff5_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff5_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff5_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff5_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage5          
                neg     t, w51
                call    #coeff5_b1       ' value -= w51 * -1.448638916015625
                neg     t, w52
                call    #coeff5_b2       ' value -= w52 * 0.8216552734375
                mov     w50, value       ' w50 = value
                mov     t, w51
                call    #coeff5_a1       ' value += w51 * -1.0
                mov     t, w52
                call    #coeff5_a2       ' value += w52 * 0.0
                mov     w52, w51
                mov     w51, w50         ' w52 <- w51 <- w50
stage5_ret      ret

w50             long    0
w51             long    0
w52             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.633209228515625+0.403564453125j), (0.633209228515625-0.403564453125j)] }}

coeff6_b1                                ' value += t * -1.266418 [ +1.44340 hex ]
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
coeff6_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff6_b2                                ' value += t * 0.563812 [ +0.90560 hex ]
                sar     t, #1
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #6
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff6_b2_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff6_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff6_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff6_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff6_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage6          
                neg     t, w61
                call    #coeff6_b1       ' value -= w61 * -1.26641845703125
                neg     t, w62
                call    #coeff6_b2       ' value -= w62 * 0.563812255859375
                mov     w60, value       ' w60 = value
                mov     t, w61
                call    #coeff6_a1       ' value += w61 * -1.0
                mov     t, w62
                call    #coeff6_a2       ' value += w62 * 0.0
                mov     w62, w61
                mov     w61, w60         ' w62 <- w61 <- w60
stage6_ret      ret

w60             long    0
w61             long    0
w62             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.5902252197265625+0.25225830078125j), (0.5902252197265625-0.25225830078125j)] }}

coeff7_b1                                ' value += t * -1.180450 [ +1.2e320 hex ]
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
coeff7_b1_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff7_b2                                ' value += t * 0.411987 [ +0.69780 hex ]
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #4
                sub     value, t
coeff7_b2_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff7_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff7_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff7_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff7_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage7          
                neg     t, w71
                call    #coeff7_b1       ' value -= w71 * -1.180450439453125
                neg     t, w72
                call    #coeff7_b2       ' value -= w72 * 0.4119873046875
                mov     w70, value       ' w70 = value
                mov     t, w71
                call    #coeff7_a1       ' value += w71 * -1.0
                mov     t, w72
                call    #coeff7_a2       ' value += w72 * 0.0
                mov     w72, w71
                mov     w71, w70         ' w72 <- w71 <- w70
stage7_ret      ret

w70             long    0
w71             long    0
w72             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(1+0j), 0.0], p = [(0.58087158203125+0.0884246826171875j), (0.58087158203125-0.0884246826171875j)] }}

coeff8_b1                                ' value += t * -1.161743 [ +1.29680 hex ]
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
coeff8_b1_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff8_b2                                ' value += t * 0.345230 [ +0.58610 hex ]
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #5
                add     value, t
coeff8_b2_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff8_a1                                ' value += t * -1.000000 [ +1.00000 hex ]
                sub     value, t
coeff8_a1_ret   ret                      ' 8 cycles (I2S: 0.081 us, standard: 0.100 us) 2 instructs

coeff8_a2                                ' value += t * 0.000000 [ +0.00000 hex ]
coeff8_a2_ret   ret                      ' 4 cycles (I2S: 0.041 us, standard: 0.050 us) 1 instructs

stage8          
                neg     t, w81
                call    #coeff8_b1       ' value -= w81 * -1.1617431640625
                neg     t, w82
                call    #coeff8_b2       ' value -= w82 * 0.3452301025390625
                mov     w80, value       ' w80 = value
                mov     t, w81
                call    #coeff8_a1       ' value += w81 * -1.0
                mov     t, w82
                call    #coeff8_a2       ' value += w82 * 0.0
                mov     w82, w81
                mov     w81, w80         ' w82 <- w81 <- w80
stage8_ret      ret

w80             long    0
w81             long    0
w82             long    0

t               res     1
{{ 16 bits per coefficient }}
{{ 1580 cycles (I2S: 16.073 us, standard: 19.750 us) 395 instructs }}
parm            res     1
time            res     1
period          res     1
in_addr         res     1
out_addr        res     1
                FIT     $1F0
