{{ band_pass2.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_addr, parm
                add     parm, #4
		mov	out_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  value, in_addr
                call    #filter
                wrlong  value, out_addr
                jmp     #:filtloop


filter          
                sar     value, #7
                call    #stage1          ' stage gain = 198.123155545, cumul actual gain = 0.658423945812
                                         ' poles only = 84.278265064
                sar     value, #2
                call    #stage2          ' stage gain = 50.5496014864, cumul actual gain = 0.785448762043
                                         ' poles only = 67.4025972109
                sar     value, #5
                call    #stage3          ' stage gain = 25.1727277008, cumul actual gain = 0.678005903934
                                         ' poles only = 27.9413275224
                sar     value, #1
                call    #stage4          ' stage gain = 8.60136001662, cumul actual gain = 0.699725175265
                                         ' poles only = 23.0419299465
                sar     value, #3
                call    #stage5          ' stage gain = 5.56748115992, cumul actual gain = 0.705242304348
                                         ' poles only = 16.8635238359
                shl     value, #1
                call    #stage6          ' stage gain = 10.1190359849, cumul actual gain = 0.897025836668
                                         ' poles only = 14.7736331575
                sar     value, #1
                call    #stage7          ' stage gain = 8.36856490587, cumul actual gain = 0.731907068795
                                         ' poles only = 12.992813967
                sar     value, #1
                call    #stage8          ' stage gain = 14.0701380028, cumul actual gain = 0.612811347727
                                         ' poles only = 12.388894752
filter_ret      ret                      ' cumul actual gain = 0.524709857046

value           long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(-0.672210693359375+0.7403411865234375j), (-0.672210693359375-0.7403411865234375j)], p = [(0.4996337890625+0.8582763671875j), (0.4996337890625-0.8582763671875j)] }}

coeff1_b1                                ' value += t * -0.999268 [ +0.ffd00 hex ]
                sub     value, t
                sar     t, #10
                add     value, t
                sar     t, #2
                sub     value, t
coeff1_b1_ret   ret                      ' 24 cycles (I2S: 0.244 us, standard: 0.300 us) 6 instructs

coeff1_b2                                ' value += t * 0.986267 [ +0.fc7c0 hex ]
                add     value, t
                sar     t, #6
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #5
                sub     value, t
coeff1_b2_ret   ret                      ' 32 cycles (I2S: 0.326 us, standard: 0.400 us) 8 instructs

coeff1_a1                                ' value += t * 1.344421 [ +1.582c0 hex ]
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #6
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff1_a1_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff1_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff1_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage1          
                neg     t, w11
                call    #coeff1_b1       ' value -= w11 * -0.999267578125
                neg     t, w12
                call    #coeff1_b2       ' value -= w12 * 0.98626708984375
                mov     w10, value       ' w10 = value
                mov     t, w11
                call    #coeff1_a1       ' value += w11 * 1.34442138671875
                mov     t, w12
                call    #coeff1_a2       ' value += w12 * 0.999969482421875
                mov     w12, w11
                mov     w11, w10         ' w12 <- w11 <- w10
stage1_ret      ret

w10             long    0
w11             long    0
w12             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(-0.11993408203125+0.992767333984375j), (-0.11993408203125-0.992767333984375j)], p = [(0.2530059814453125+0.959503173828125j), (0.2530059814453125-0.959503173828125j)] }}

coeff2_b1                                ' value += t * -0.506012 [ +0.818a0 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #6
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                sub     value, t
coeff2_b1_ret   ret                      ' 44 cycles (I2S: 0.448 us, standard: 0.550 us) 11 instructs

coeff2_b2                                ' value += t * 0.984650 [ +0.fc120 hex ]
                add     value, t
                sar     t, #6
                sub     value, t
                sar     t, #6
                add     value, t
                sar     t, #3
                add     value, t
coeff2_b2_ret   ret                      ' 32 cycles (I2S: 0.326 us, standard: 0.400 us) 8 instructs

coeff2_a1                                ' value += t * 0.239868 [ +0.3d680 hex ]
                sar     t, #2
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
coeff2_a1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff2_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff2_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage2          
                neg     t, w21
                call    #coeff2_b1       ' value -= w21 * -0.506011962890625
                neg     t, w22
                call    #coeff2_b2       ' value -= w22 * 0.984649658203125
                mov     w20, value       ' w20 = value
                mov     t, w21
                call    #coeff2_a1       ' value += w21 * 0.2398681640625
                mov     t, w22
                call    #coeff2_a2       ' value += w22 * 0.999969482421875
                mov     w22, w21
                mov     w21, w20         ' w22 <- w21 <- w20
stage2_ret      ret

w20             long    0
w21             long    0
w22             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.0384674072265625+0.9992523193359375j), (0.0384674072265625-0.9992523193359375j)], p = [(0.47833251953125+0.8545074462890625j), (0.47833251953125-0.8545074462890625j)] }}

coeff3_b1                                ' value += t * -0.956665 [ +0.f4e80 hex ]
                sub     value, t
                sar     t, #4
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
coeff3_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff3_b2                                ' value += t * 0.958984 [ +0.f5800 hex ]
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff3_b2_ret   ret                      ' 40 cycles (I2S: 0.407 us, standard: 0.500 us) 10 instructs

coeff3_a1                                ' value += t * -0.076935 [ +0.13b20 hex ]
                sar     t, #4
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
coeff3_a1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff3_a2                                ' value += t * 0.999985 [ +0.ffff0 hex ]
                add     value, t
                sar     t, #16
                sub     value, t
coeff3_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage3          
                neg     t, w31
                call    #coeff3_b1       ' value -= w31 * -0.9566650390625
                neg     t, w32
                call    #coeff3_b2       ' value -= w32 * 0.958984375
                mov     w30, value       ' w30 = value
                mov     t, w31
                call    #coeff3_a1       ' value += w31 * -0.076934814453125
                mov     t, w32
                call    #coeff3_a2       ' value += w32 * 0.9999847412109375
                mov     w32, w31
                mov     w31, w30         ' w32 <- w31 <- w30
stage3_ret      ret

w30             long    0
w31             long    0
w32             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.0879669189453125+0.9961090087890625j), (0.0879669189453125-0.9961090087890625j)], p = [(0.2669830322265625+0.94000244140625j), (0.2669830322265625-0.94000244140625j)] }}

coeff4_b1                                ' value += t * -0.533966 [ +0.88b20 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #4
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
coeff4_b1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff4_b2                                ' value += t * 0.954880 [ +0.f4730 hex ]
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
coeff4_b2_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff4_a1                                ' value += t * -0.175934 [ +0.2d0a0 hex ]
                sar     t, #3
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #5
                sub     value, t
                sar     t, #2
                sub     value, t
coeff4_a1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff4_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff4_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage4          
                neg     t, w41
                call    #coeff4_b1       ' value -= w41 * -0.533966064453125
                neg     t, w42
                call    #coeff4_b2       ' value -= w42 * 0.9548797607421875
                mov     w40, value       ' w40 = value
                mov     t, w41
                call    #coeff4_a1       ' value += w41 * -0.175933837890625
                mov     t, w42
                call    #coeff4_a2       ' value += w42 * 0.999969482421875
                mov     w42, w41
                mov     w41, w40         ' w42 <- w41 <- w40
stage4_ret      ret

w40             long    0
w41             long    0
w42             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.620574951171875+0.7841339111328125j), (0.620574951171875-0.7841339111328125j)], p = [(0.44256591796875+0.858734130859375j), (0.44256591796875-0.858734130859375j)] }}

coeff5_b1                                ' value += t * -0.885132 [ +0.e2980 hex ]
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
coeff5_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff5_b2                                ' value += t * 0.933289 [ +0.eeec0 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff5_b2_ret   ret                      ' 64 cycles (I2S: 0.651 us, standard: 0.800 us) 16 instructs

coeff5_a1                                ' value += t * -1.241150 [ +1.3dbc0 hex ]
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #4
                add     value, t
coeff5_a1_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff5_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff5_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage5          
                neg     t, w51
                call    #coeff5_b1       ' value -= w51 * -0.8851318359375
                neg     t, w52
                call    #coeff5_b2       ' value -= w52 * 0.93328857421875
                mov     w50, value       ' w50 = value
                mov     t, w51
                call    #coeff5_a1       ' value += w51 * -1.24114990234375
                mov     t, w52
                call    #coeff5_a2       ' value += w52 * 0.999969482421875
                mov     w52, w51
                mov     w51, w50         ' w52 <- w51 <- w50
stage5_ret      ret

w50             long    0
w51             long    0
w52             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.6501922607421875+0.7597503662109375j), (0.6501922607421875-0.7597503662109375j)], p = [(0.2981109619140625+0.9164886474609375j), (0.2981109619140625-0.9164886474609375j)] }}

coeff6_b1                                ' value += t * -0.596222 [ +0.98a20 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #4
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #4
                sub     value, t
coeff6_b1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff6_b2                                ' value += t * 0.928818 [ +0.edc70 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
coeff6_b2_ret   ret                      ' 64 cycles (I2S: 0.651 us, standard: 0.800 us) 16 instructs

coeff6_a1                                ' value += t * -1.300385 [ +1.4ce60 hex ]
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #2
                add     value, t
coeff6_a1_ret   ret                      ' 64 cycles (I2S: 0.651 us, standard: 0.800 us) 16 instructs

coeff6_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff6_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage6          
                neg     t, w61
                call    #coeff6_b1       ' value -= w61 * -0.596221923828125
                neg     t, w62
                call    #coeff6_b2       ' value -= w62 * 0.9288177490234375
                mov     w60, value       ' w60 = value
                mov     t, w61
                call    #coeff6_a1       ' value += w61 * -1.300384521484375
                mov     t, w62
                call    #coeff6_a2       ' value += w62 * 0.999969482421875
                mov     w62, w61
                mov     w61, w60         ' w62 <- w61 <- w60
stage6_ret      ret

w60             long    0
w61             long    0
w62             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.732757568359375+0.68048095703125j), (0.732757568359375-0.68048095703125j)], p = [(0.3950042724609375+0.8714752197265625j), (0.3950042724609375-0.8714752197265625j)] }}

coeff7_b1                                ' value += t * -0.790009 [ +0.ca3e0 hex ]
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                sub     value, t
                sar     t, #5
                add     value, t
coeff7_b1_ret   ret                      ' 48 cycles (I2S: 0.488 us, standard: 0.600 us) 12 instructs

coeff7_b2                                ' value += t * 0.915497 [ +0.ea5e0 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                add     value, t
                sar     t, #4
                sub     value, t
coeff7_b2_ret   ret                      ' 56 cycles (I2S: 0.570 us, standard: 0.700 us) 14 instructs

coeff7_a1                                ' value += t * -1.465515 [ +1.772c0 hex ]
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #3
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
coeff7_a1_ret   ret                      ' 64 cycles (I2S: 0.651 us, standard: 0.800 us) 16 instructs

coeff7_a2                                ' value += t * 0.999985 [ +0.ffff0 hex ]
                add     value, t
                sar     t, #16
                sub     value, t
coeff7_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage7          
                neg     t, w71
                call    #coeff7_b1       ' value -= w71 * -0.790008544921875
                neg     t, w72
                call    #coeff7_b2       ' value -= w72 * 0.915496826171875
                mov     w70, value       ' w70 = value
                mov     t, w71
                call    #coeff7_a1       ' value += w71 * -1.46551513671875
                mov     t, w72
                call    #coeff7_a2       ' value += w72 * 0.9999847412109375
                mov     w72, w71
                mov     w71, w70         ' w72 <- w71 <- w70
stage7_ret      ret

w70             long    0
w71             long    0
w72             long    0

{{ --------------------------------------------- }}
{{ Filter stage, two pole, z = [(0.9259033203125+0.3777313232421875j), (0.9259033203125-0.3777313232421875j)], p = [(0.3433685302734375+0.8919677734375j), (0.3433685302734375-0.8919677734375j)] }}

coeff8_b1                                ' value += t * -0.686737 [ +0.afce0 hex ]
                sar     t, #1
                sub     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                sub     value, t
                sar     t, #6
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #3
                add     value, t
coeff8_b1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff8_b2                                ' value += t * 0.913498 [ +0.e9db0 hex ]
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                add     value, t
                sar     t, #3
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #1
                add     value, t
                sar     t, #2
                sub     value, t
coeff8_b2_ret   ret                      ' 72 cycles (I2S: 0.732 us, standard: 0.900 us) 18 instructs

coeff8_a1                                ' value += t * -1.851807 [ +1.da100 hex ]
                sub     value, t
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #1
                sub     value, t
                sar     t, #2
                add     value, t
                sar     t, #2
                sub     value, t
                sar     t, #5
                sub     value, t
coeff8_a1_ret   ret                      ' 52 cycles (I2S: 0.529 us, standard: 0.650 us) 13 instructs

coeff8_a2                                ' value += t * 0.999969 [ +0.fffe0 hex ]
                add     value, t
                sar     t, #15
                sub     value, t
coeff8_a2_ret   ret                      ' 16 cycles (I2S: 0.163 us, standard: 0.200 us) 4 instructs

stage8          
                neg     t, w81
                call    #coeff8_b1       ' value -= w81 * -0.686737060546875
                neg     t, w82
                call    #coeff8_b2       ' value -= w82 * 0.9134979248046875
                mov     w80, value       ' w80 = value
                mov     t, w81
                call    #coeff8_a1       ' value += w81 * -1.851806640625
                mov     t, w82
                call    #coeff8_a2       ' value += w82 * 0.999969482421875
                mov     w82, w81
                mov     w81, w80         ' w82 <- w81 <- w80
stage8_ret      ret

w80             long    0
w81             long    0
w82             long    0

t               res     1
{{ 16 bits per coefficient }}
{{ 1916 cycles (I2S: 19.491 us, standard: 23.950 us) 479 instructs }}
parm            res     1
time            res     1
period          res     1
in_addr         res     1
out_addr        res     1
                FIT     $1F0
