{{ ssb_filter.spin }}

CON

OBJ


PUB Start (param_address)
  RESULT := cognew (@entry, param_address)

DAT
                ORG     0
entry
                mov     parm, PAR
                rdlong  period, parm
		add	parm, #4
		rdlong  time, parm
		add	parm, #4
	        mov     in_re_addr, parm
                add     parm, #4
	        mov     in_im_addr, parm
                add     parm, #4
		mov	out_re_addr, parm
                add     parm, #4
		mov	out_im_addr, parm

:filtloop       WAITCNT time, period   ' synchronize
		rdlong  vx, in_re_addr
                rdlong  vy, in_im_addr
                call    #filter
                wrlong  vx, out_re_addr
                wrlong  vy, out_im_addr
                jmp     #:filtloop


filter          
                sar     vx, #7
                sar     vy, #7
                call    #stage1          ' stage gain = 211.45016737, cumul actual gain = 0.828538904156
                                         ' poles only = 106.052979732
                sar     vx, #5
                sar     vy, #5
                call    #stage2          ' stage gain = 14.4027966193, cumul actual gain = 0.897001063046
                                         ' poles only = 30.9739319231
                sar     vx, #2
                sar     vy, #2
                call    #stage3          ' stage gain = 5.24885778403, cumul actual gain = 0.726942218501
                                         ' poles only = 21.2252091806
                sar     vx, #1
                sar     vy, #1
                call    #stage4          ' stage gain = 10.8489864282, cumul actual gain = 0.557702656667
                                         ' poles only = 31.0984153341
                shl     vx, #2
                shl     vy, #2
                call    #stage5          ' stage gain = 52.9311928907, cumul actual gain = 0.657020243862
                                         ' poles only = 103.498342418
                shl     vx, #2
                shl     vy, #2
filter_ret      ret                      ' cumul actual gain = 0.550439078509

vx              long    0
vy              long    0

{{ --------------------------------------------- }}
{{ Filter stage, one complex pole, z = [(-0.98193359375000111-0.18847656249999997j)], p = [(0.98999023437526823+0.033935546878148259j)] }}

coeff1_b                                 ' v += t * (-0.989990234375-0.033935546875j) [ -0.fd700-0.08b00j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #6
                sar     ty, #6
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #5
                sar     ty, #5
                sub     vx, tx
                sub     vy, ty
                sar     tx, #4
                sar     ty, #4
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
coeff1_b_ret    ret

coeff1_a                                 ' v += t * (0.98193359375+0.188232421875j) [ +0.fb600+0.30300j hex ]
                mov     tx, x
                mov     ty, y
                add     vx, tx
                add     vy, ty
                sar     tx, #5
                sar     ty, #5
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #6
                sar     ty, #6
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
coeff1_a_ret    ret

stage1          
                neg     x, w11x
                neg     y, w11y
                call    #coeff1_b        ' value -= w11 * (-0.989990234375-0.033935546875j)
                mov     w10x, vx         ' w10 = value
                mov     w10y, vy
                mov     x, w11x
                mov     y, w11y
                call    #coeff1_a        ' value += w11 * (0.98193359375+0.188232421875j)
                mov     w11x, w10x       ' w11 <- w10
                mov     w11y, w10y
stage1_ret      ret

w10x            long    0
w10y            long    0
w11x            long    0
w11y            long    0

{{ --------------------------------------------- }}
{{ Filter stage, one complex pole, z = [(0.851562499999997+0.52392578124999023j)], p = [(0.96435546875181266+0.080566406243994582j)] }}

coeff2_b                                 ' v += t * (-0.96435546875-0.080322265625j) [ -0.f6e00-0.14900j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #4
                sar     ty, #4
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #4
                sar     ty, #4
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
coeff2_b_ret    ret

coeff2_a                                 ' v += t * (-0.851318359375-0.523681640625j) [ -0.d9f00-0.86100j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #5
                sar     ty, #5
                add     vx, tx
                add     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #4
                sar     ty, #4
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #5
                sar     ty, #5
                sub     vx, tx
                sub     vy, ty
coeff2_a_ret    ret

stage2          
                neg     x, w21x
                neg     y, w21y
                call    #coeff2_b        ' value -= w21 * (-0.96435546875-0.080322265625j)
                mov     w20x, vx         ' w20 = value
                mov     w20y, vy
                mov     x, w21x
                mov     y, w21y
                call    #coeff2_a        ' value += w21 * (-0.851318359375-0.523681640625j)
                mov     w21x, w20x       ' w21 <- w20
                mov     w21y, w20y
stage2_ret      ret

w20x            long    0
w20y            long    0
w21x            long    0
w21y            long    0

{{ --------------------------------------------- }}
{{ Filter stage, one complex pole, z = [(0.90747070312500766+0.41943359375001077j)], p = [(0.93579101561976696+0.17968750000310205j)] }}

coeff3_b                                 ' v += t * (-0.935546875-0.1796875j) [ -0.ef800-0.2e000j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #5
                sar     ty, #5
                add     vx, tx
                add     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
coeff3_b_ret    ret

coeff3_a                                 ' v += t * (-0.907470703125-0.41943359375j) [ -0.e8500-0.6b600j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #5
                sar     ty, #5
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
coeff3_a_ret    ret

stage3          
                neg     x, w31x
                neg     y, w31y
                call    #coeff3_b        ' value -= w31 * (-0.935546875-0.1796875j)
                mov     w30x, vx         ' w30 = value
                mov     w30y, vy
                mov     x, w31x
                mov     y, w31y
                call    #coeff3_a        ' value += w31 * (-0.907470703125-0.41943359375j)
                mov     w31x, w30x       ' w31 <- w30
                mov     w31y, w30y
stage3_ret      ret

w30x            long    0
w30y            long    0
w31x            long    0
w31y            long    0

{{ --------------------------------------------- }}
{{ Filter stage, one complex pole, z = [(0.99853515624999323-0.053222656250008236j)], p = [(0.92578125000500133+0.28222656250123818j)] }}

coeff4_b                                 ' v += t * (-0.92578125-0.2822265625j) [ -0.ed000-0.48400j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
                sar     tx, #5
                sar     ty, #5
                sub     vx, tx
                sub     vy, ty
coeff4_b_ret    ret

coeff4_a                                 ' v += t * (-0.998291015625+0.05322265625j) [ -0.ff900+0.0da00j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #9
                sar     ty, #9
                add     vx, tx
                add     vy, ty
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #4
                sar     ty, #4
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
coeff4_a_ret    ret

stage4          
                neg     x, w41x
                neg     y, w41y
                call    #coeff4_b        ' value -= w41 * (-0.92578125-0.2822265625j)
                mov     w40x, vx         ' w40 = value
                mov     w40y, vy
                mov     x, w41x
                mov     y, w41y
                call    #coeff4_a        ' value += w41 * (-0.998291015625+0.05322265625j)
                mov     w41x, w40x       ' w41 <- w40
                mov     w41y, w40y
stage4_ret      ret

w40x            long    0
w40y            long    0
w41x            long    0
w41y            long    0

{{ --------------------------------------------- }}
{{ Filter stage, one complex pole, z = [(0.98510742187500644-0.17089843749999131j)], p = [(0.93188476562314548+0.33520507812351624j)] }}

coeff5_b                                 ' v += t * (-0.931640625-0.3349609375j) [ -0.ee800-0.55c00j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                sub     vx, tx
                sub     vy, ty
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
coeff5_b_ret    ret

coeff5_a                                 ' v += t * (-0.985107421875+0.170654296875j) [ -0.fc300+0.2bb00j hex ]
                mov     tx, x
                mov     ty, y
                sub     vx, tx
                sub     vy, ty
                sar     tx, #6
                sar     ty, #6
                add     vx, tx
                add     vy, ty
                sar     tx, #4
                sar     ty, #4
                sub     vx, tx
                sub     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                neg     tx, y
                mov     ty, x
                sar     tx, #3
                sar     ty, #3
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                add     vx, tx
                add     vy, ty
                sar     tx, #1
                sar     ty, #1
                add     vx, tx
                add     vy, ty
                sar     tx, #3
                sar     ty, #3
                sub     vx, tx
                sub     vy, ty
                sar     tx, #1
                sar     ty, #1
                add     vx, tx
                add     vy, ty
                sar     tx, #2
                sar     ty, #2
                sub     vx, tx
                sub     vy, ty
coeff5_a_ret    ret

stage5          
                neg     x, w51x
                neg     y, w51y
                call    #coeff5_b        ' value -= w51 * (-0.931640625-0.3349609375j)
                mov     w50x, vx         ' w50 = value
                mov     w50y, vy
                mov     x, w51x
                mov     y, w51y
                call    #coeff5_a        ' value += w51 * (-0.985107421875+0.170654296875j)
                mov     w51x, w50x       ' w51 <- w50
                mov     w51y, w50y
stage5_ret      ret

w50x            long    0
w50y            long    0
w51x            long    0
w51y            long    0

x               res     1
y               res     1
tx              res     1
ty              res     1
{{ 12 bits per coefficient }}
{{ 2020 cycles (I2S: 20.549 us, standard: 25.250 us) 505 instructs }}
parm            res     1
time            res     1
period          res     1
in_re_addr      res     1
in_im_addr      res     1
out_re_addr     res     1
out_im_addr     res     1
                FIT     $1F0
